import 'package:cl_appbase/api.dart';

import '../api.dart';
import '../api_resource.dart';

class ListHubResource extends ListApiResource {
  ListHubResource(ApiBase api, String endpointSuffix, factory)
      : super(api, endpointSuffix, factory);

  Future<int> getCount() async => await getMetaData('count');

  Future<TData> getMetaData<TData>(String key) async {
    final response = await request<TData, TData>(
        api.baseUrl, '$endpointSuffix/\$$key', null, ApiRequestMethod.GET,
        headers: api.getRequestHeaders());
    response.throwOnError();
    return response.data;
  }
}

class SingleObjectHubResource extends SingleObjectApiResource {
  SingleObjectHubResource(ApiBase api, String endpointSuffix, factory)
      : super(api, endpointSuffix, factory);

  Future<TData> getMetaData<TData>(String key) async {
    final response = await request<TData, TData>(
        api.baseUrl, '$endpointSuffix/\$$key', null, ApiRequestMethod.GET,
        headers: api.getRequestHeaders());
    response.throwOnError();
    return response.data;
  }
}
