import 'package:flutter/material.dart';

class StateBuilder<TState> extends StatelessWidget {
  final Stream<TState> stream;
  final Widget Function(BuildContext context, TState? state) builder;

  const StateBuilder({Key? key, required this.stream, required this.builder})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return StreamBuilder<TState>(stream: stream.distinct(), builder: _builder);
  }

  Widget _builder(BuildContext context, AsyncSnapshot<TState> snapshot) {
    return builder(context, snapshot.data);
  }
}
